import java.util.Scanner;
import java.math.BigInteger;

public class Collatz {

    public static long f(long n)
    {
	assert(n > 0);
	return ((n % 2) == 0) ? n / 2 : 3 * n + 1;
    }

    public static BigInteger f(BigInteger n)
    {
	final BigInteger zero = BigInteger.valueOf(0);
	final BigInteger one = BigInteger.valueOf(1);
	final BigInteger two = BigInteger.valueOf(2);
	final BigInteger three = BigInteger.valueOf(3);

	assert(n.compareTo(zero) > 0);
	
	if (n.mod(two).equals(zero)) {
	    return n.divide(two);
	} else {
	    return n.multiply(three).add(one);
	}
    }

    public static void collatz(long n)
    {
	if (n == 1) {
	    System.out.println(n);
	} else {
	    System.out.print(n + " ");
	    collatz(f(n));
	}
    }

    public static void collatz(BigInteger n)
    {
	final BigInteger one = BigInteger.valueOf(1);
	
	if (n.equals(one)) {
	    System.out.println(n);
	} else {
	    System.out.print(n + " ");
	    collatz(f(n));
	}
    }

    public static void main(String[] args)
    {
	Scanner in = new Scanner(System.in);
	while (in.hasNext()) {
	    if (in.hasNextLong()) {
		collatz(in.nextLong());
	    } else if (in.hasNextBigInteger()) {
		collatz(in.nextBigInteger());
	    } else {
		System.err.println("unexpected input: " + in.next());
		System.exit(1);
	    }
	}
    }
} 
